### Method

# EBook BookClient add_contacts_sync

since: 3.4

#### Declaration [src]

    gboolean
    e_book_client_add_contacts_sync (
      EBookClient* client,
      GSList* contacts,
      guint32 opflags,
      GSList** out_added_uids,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Adds `contacts` to `client` and sets `out_added_uids` to the UIDs of newly added contacts if successful. This `GSList` should be freed with e_client_util_free_string_slist().

If any of the contacts cannot be inserted, all of the insertions will be reverted and this method will return `FALSE`.

Note: This is not modifying original `contacts`, thus if it’s needed, then use e_contact_set (contact, E_CONTACT_UID, new_uid).

Available since: 3.4

#### Parameters

`contacts`

  Type: A list of `EContact*`

  A `GSList` of `EContact` objects to add.

  The data is owned by the caller of the method.

`opflags`

  Type: `EBookOperationFlags`

  Bit-or of `EBookOperationFlags`.

`out_added_uids`

  Type: A list of `utf8`

  UIDs of newly added contacts; can be `NULL`.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.
  Each element is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  A `GCancellable`; can be `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if successful, `FALSE` otherwise.